/******************************************************************************
 *
 *	Tic Tac Toe V0.90 (c) David A.S.Crofts
 *
 *	23 Brisbane Street
 *	Berwick Victoria 3806
 *	Australia
 *
 *	email: dasc1961@netscape.net
 *
 *****************************************************************************/

#ifndef __TTT_H__
#define __TTT_H__

#include <PalmTypes.h>


/***********************************************************************
 *
 *	Internal Constants
 *
 ***********************************************************************/

#define  tttAppVersionNum		0x0101
#define  tttAppCreator			'ttto'

#define  version20			0x02000000


#define  MAX_STATES 	10

#define  PLAYER_PIECE   0
#define  COMPUTER_PIECE 1
#define  NO_PIECE       2


#ifndef  TRUE
#define  TRUE   	1
#endif

#ifndef  FALSE
#define  FALSE  	0
#endif

#ifndef	 NULL
#define  NULL		0L
#endif


/***********************************************************************
 *
 *	Internal Structures
 *
 ***********************************************************************/

typedef struct state_block {
    struct state_block *memPtr;
    MemHandle		memHandle;
    UInt16   		board[10];
    UInt16		turn;
    Int16		piece;
} STATE, *STATE_PTR;


typedef struct sucessor_block {
    struct sucessor_block      *memPtr;
    MemHandle			memHandle;
    UInt16			num;
    STATE_PTR   		ptr[MAX_STATES];
} SUCESSOR, *SUCESSOR_PTR;


typedef struct PieceCoordType {

    Int16	row;
    Int16	col;

} PieceCoordType;


typedef enum GameStateType {

    gameInProgress,
    gameWon,
    gameLost,
    gameDraw

} GameStateType;


typedef struct GameType {

    Int8		numPlayers;
    GameStateType	P1state;
    GameStateType	P2state;
    Boolean		P1reversed;
    Boolean 		P2IsFirstMove;
    Int16		P1square[10];
    Int16		P2square[10];
    Int16		P2FirstMove;
    Int16		P1Draws;
    Int16		P1Loses;
    Int16		P2NoughtWins;
    Int16		P2CrossWins;
    Int16		P2Draws;
    Int32		P1value;
    Int32		P2value;
    UInt16		P1turn;
    UInt16		P2turn;

} GameType;


typedef struct TTTPrefType {

    UInt32		signature;
    GameType		game;

} TTTPrefType;
	

#define	TTTPrefSignature	'TtTo'


#endif	// __TTT_H__
